using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace testproject5
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();



            DataTable t1 = new DataTable("t1");
            t1.CaseSensitive = false;
            
            DataColumn t1k1=new DataColumn("k1", typeof(System.String));
            t1.Columns.Add(t1k1);
            t1.PrimaryKey=new DataColumn[] {t1k1};

            DataRow arow=null;
            
            arow=t1.NewRow();
            arow["k1"]="k1v1";
            t1.Rows.Add(arow);

            arow=t1.NewRow();
            arow["k1"]="k1v2";
            t1.Rows.Add(arow);

            



            DataTable t2 = new DataTable("t2");
            t2.CaseSensitive = false;

            DataColumn t2k1=new DataColumn("k1", typeof(System.String));
            t2.Columns.Add(t2k1);

            DataColumn t2k2=new DataColumn("k2", typeof(System.String));
            t2.Columns.Add(t2k2);

            t2.PrimaryKey=new DataColumn[] {t2k1, t2k2};

            arow=t2.NewRow();
            arow["k1"]="K1v1";  //change to uppercase just for fun
            arow["k2"]="k2v1";
            t2.Rows.Add(arow);

            arow=t2.NewRow();
            arow["k1"]="k1v1";
            arow["k2"]="k2v2";
            t2.Rows.Add(arow);

            arow = t2.NewRow();
            arow["k1"] = "k1v2";
            arow["k2"] = "k2v3";
            t2.Rows.Add(arow);


            DataSet ds = new DataSet("ds");

            ds.Tables.Add(t1);
            ds.Tables.Add(t2);

            DataRelation dr1=new DataRelation("dr1", t1k1, t2k1);
            ds.Relations.Add(dr1);



            ds.AcceptChanges();

            ultraGrid1.DataSource=ds;

            int icount = 0;
            foreach (DataRow arow2 in t1.Rows[0].GetChildRows(dr1))
            {
                icount++;
            }

            MessageBox.Show("Via the DataRelation there are  " + icount + " child records for the first parent record.");



        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //may be able to enable case-insensitivity here
        }
    }
}